=== debian/changelog ===
86box (5.0) UNRELEASED; urgency=medium

  * Bump release.

 -- Jasmine Iwanek <jriwanek@gmail.com>  Wed, 16 Apr 2025 22:08:04 +0200
